import { world } from '@minecraft/server';

function blocksSideList(block) {
    let result = {}

    result.up = world.getDimension("overworld").getBlock({ x: block.location.x, y: block.location.y + 1, z: block.location.z });
    result.down = world.getDimension("overworld").getBlock({ x: block.location.x, y: block.location.y - 1, z: block.location.z });

    result.north = world.getDimension("overworld").getBlock({ x: block.location.x, y: block.location.y, z: block.location.z - 1 });
    result.south = world.getDimension("overworld").getBlock({ x: block.location.x, y: block.location.y, z: block.location.z + 1 });

    result.west = world.getDimension("overworld").getBlock({ x: block.location.x - 1, y: block.location.y, z: block.location.z });
    result.east = world.getDimension("overworld").getBlock({ x: block.location.x + 1, y: block.location.y, z: block.location.z });

    return result
}

const verifyItems = (block, packs, itemR) => {
    for (const t of Object.keys(blocksSideList(block))) {
      
        if (blocksSideList(block)[t].getComponent("inventory").container.size == 54) {
            const blockKInv = blocksSideList(block)[t]
            const invInPut = blockKInv.getComponent("inventory").container
            let itemq = 0
            for (let t = 0; t < invInPut.size; t++) {
                const item = invInPut.getItem(t)
                
                if (item) {
                if (item.typeId == itemR) {
                  itemq += item.amount 
                  
                }
                }
            }
            return {
                quantity: itemq, 
                test: Math.trunc(itemq / 64) >= packs
            }
        }
    }
}

const runCommand = (cmd) => world.getDimension("overworld").runCommandAsync(String(cmd))

export { blocksSideList, runCommand, verifyItems }